<?php

namespace Slovocast\Domain\Entity;

use DateTimeImmutable;
use Slovocast\Domain\Entity as EntityTrait;

class Episode
{
    use EntityTrait;

    private string $duration;

    public function __construct(
        private string $title,
        private string $link,
        private int $length,
        private string $description,
        private int $serialNumber,
        private bool $explicit,
        private DateTimeImmutable $publishedDate,
        private string $episodeType,
    ) {
        $this->duration = $this->parseDuration($this->length);
    }

    public function getTitle(): string
    {
        return $this->title;
    }

    public function getLink(): string
    {
        return $this->link;
    }

    public function getLength(): int
    {
        return $this->length;
    }

    public function getDuration(): string
    {
        return $this->duration;
    }

    public function getSerialNumber(): int
    {
        return $this->serialNumber;
    }

    public function isExplicit(): bool
    {
        return $this->explicit;
    }

    /**
     * @TODO Figure out how to parse second to HH:MM:SS
     */
    public static function parseDuration(int $length): string
    {
        $hours = floor($length / 3600);
        $minutes = floor($length / 60) % 60;
        $seconds = $length % 60;

        return "";
    }

    /**
     * @param array $props The properties of the method
     */
    public static function fromArray(array $props): self
    {
        $episode = new self(
            $props['title'],
            $props['link'],
            (int) $props['length'],
            $props['description'],
            $props['serialNumber'],
            (bool) $props['explicit'],
            $props['publishedDate'],
            $props['episdoeType']
        );

        if ($props['id']) {
            $episode->setId($props['id']);
        }

        if ($props['created_at']) {
            $episode->setCreatedAt($props['createdAt']);
        }

        if ($props['updated_id']) {
            $episode->setUpdatedAt($props['updatedAt']);
        }

        return $episode;
    }
}
