<?php

namespace Slovocast\Domain\Repository\Episode;

use Slovocast\Domain\Entity\Episode;
use Slovocast\Domain\Entity\Episode\File;
use Slovocast\Domain\RepositoryInterface;

interface EpisodeFileRepositoryInterface extends RepositoryInterface
{
    public function get(string $location): File;
    public function getFromEpisode(Episode $episode): File;
    public function create(File $file): File;
    public function update(File $file): bool;
    public function delete(File $file): bool;
}
