<?php

namespace Slovocast\Domain\Repository\Episode;

use DateTimeImmutable;
use DateTime;
use Slovocast\Domain\Entity\Episode;
use Slovocast\Domain\Repository\Episode\EpisodeRepositoryInterface;
use Slovocast\Exception\EntityNotFoundException;
use Slovocast\Infrastructure\Api\Database\DatabaseHandlerInterface;

class EpisodeRepository implements EpisodeRepositoryInterface
{
    public function __construct(
        private DatabaseHandlerInterface $db
    ) { }

    protected function getEpisodeFromResults(array $results): Episode
    {
        $results['createdAt'] = new DateTimeImmutable($results['created_at']);
        $results['updatedAt'] = new DateTime($results['updated_at']);

        return Episode::fromArray($results);
    }

    public function get(int $id): Episode
    {
        $query = "SELECT * FROM episodes WHERE id = :id";
        $statement = $this->db->getConnection()->query($query);    
        $results = $statement->fetch(\PDO::FETCH_ASSOC);

        if (!is_array($results) || !count($results)) {
            throw new EntityNotFoundException("Unable to find Episode.");
        }


    }
}
